#!/usr/bin/perl
#
# rohttpd: A httpd server.
# Copyright (C) 2006  Roberto Cappellini
#
# This file is part of rohttpd.
#
# rohttpd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# rohttpd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with rohttpd; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# =========================================================================

use strict;

sub resourcedate
{
  syswrite $_[4],
    "HTTP/1.1 200 OK\r\nContent-type: text/html\r\n\r\n".
    '<HTML><HEAD><TITLE>Metodo '. $_[1] .
    ' Risorsa ' . $_[2] . '</TITLE></HEAD><BODY>'."\r\n";

  syswrite $_[4], "Metodo: $_[1]".'<BR>'.
                  "Risorsa: $_[2]".'<BR>'.
                  "Query: $_[5]".'<BR>'.
                  "Versione HTTP: $_[3]".'<HR>'."\r\n";
    
  for my $outstring (@{$_[0]})
    {
      syswrite STDOUT, $outstring."\n";
      syswrite REMOTE, $outstring.'<BR>'."\r\n";
    }
  syswrite $_[4], '<HR>'. scalar(localtime()) . '<BR>'."\r\n";
    
  syswrite $_[4], "\r\n".'</BODY></HTML>'."\r\n";
    
}
$main::resources{'/DATE'} = \&resourcedate;

sub resourceabout
{
  syswrite $_[4],
    "HTTP/1.1 200 OK\r\nContent-type: text/html\r\n\r\n".
    '<HTML><HEAD><TITLE>Metodo '. $_[1] .
    ' Risorsa ' . $_[2] . '</TITLE></HEAD><BODY>'."\r\n";

  syswrite $_[4], "Metodo: $_[1]".'<BR>'.
                  "Risorsa: $_[2]".'<BR>'.
                  "Query: $_[5]".'<BR>'.
                  "Versione HTTP: $_[3]".'<HR>'."\r\n";
    
  for my $outstring (@{$_[0]})
    {
      syswrite STDOUT, $outstring."\n";
      syswrite REMOTE, $outstring.'<BR>'."\r\n";
    }
  syswrite $_[4], '<HR>HTTP Server scritto in Perl 5.<BR>Autore Roberto Cappellini<BR>'."\r\n";
    
  syswrite $_[4], "\r\n".'</BODY></HTML>'."\r\n";
  
}
$main::resources{'/ABOUT'} = \&resourceabout;

sub resourcehelp
{
  syswrite $_[4],
    "HTTP/1.1 200 OK\r\nContent-type: text/html\r\n\r\n".
    '<HTML><HEAD><TITLE>Metodo '. $_[1] .
    ' Risorsa ' . $_[2] . '</TITLE></HEAD><BODY>'."\r\n";

  syswrite $_[4], "Metodo: $_[1]".'<BR>'.
                  "Risorsa: $_[2]".'<BR>'.
                  "Query: $_[5]".'<BR>'.
                  "Versione HTTP: $_[3]".'<HR>'."\r\n";
    
  for my $outstring (@{$_[0]})
    {
      syswrite STDOUT, $outstring."\n";
      syswrite REMOTE, $outstring.'<BR>'."\r\n";
    }
  syswrite $_[4], '<HR>Per un proficuo uso di HTTPD Perl Pluggable impara a programmare in Perl<BR>'."\r\n";
    
  syswrite $_[4], "\r\n".'</BODY></HTML>'."\r\n\r\n\n";
  
}
$main::resources{'/HELP'} = \&resourcehelp;

# -------------------------------------------------------------------

# esegue script shell, perl ecc.. o eseguibili binari.
# uso: (my $r, my $w) = bidirezionale 'miacgi.pl';
sub bidirezionale
{
  my $rp; my $wc; my $rc; my $wp;

  pipe $rp, $wc;
  pipe $rc, $wp;

  if (fork())
  {
    # Processo padre: usa solo RP e WP
    close $wc; close $rc;

    # codice ...
    return ($rp, $wp)
  }
  else
  {
    # Processo figlio: usa solo RC e WC
    close $rp; close $wp;

    # codice ...
    
    open STDIN,  '>&', $rc;
    open STDOUT, '>&', $wc;

    # exec '/bin/sh' , "-c", "$_[0]";
    exec "$_[0]";

    exit 0;
  }
}

# $_[0] Read FD
# $_[1] Write FD
# $_[2] Scalare da scrivere.
#
# Ritorna ($stringaletta, $stringarimantentedastrivere, $nread, $nwrite)
sub readwrite
{
  my $readret = undef();
  my $writeret = undef();
  my $instring = '';
  my $rin = ''; my $win = '';
  
  if (defined($_[0])) { vec($rin,fileno($_[0]),1) = 1; }
  if (defined($_[1])) { vec($win,fileno($_[1]),1) = 1; }
  
  if ((select $rin, $win, undef(), 0) > 0)
    {
      if (vec($rin,fileno($_[0]),1))
        {
          $readret = sysread $_[0], $instring, 8192;
        }
      if (length($_[2]))
        {
          if (vec($win,fileno($_[1]),1))
            {
              $writeret = syswrite $_[1], $_[2];
            }
        }
    }
    
  return ($instring , substr($_[2], $writeret) , $readret , $writeret)
}

# $_[0] <== Reference ad array di headers da elaborare.
# $_[1] <== Comando HTTP ( GET, POST, HEAD, ... )
# $_[2] <== Risorsa come URI ( /index.html, /cgi-bin/cgi.pl, ... )
# $_[3] <== Versione HTTP ( es: HTTP/1.1 )
# $_[4] <== Reference a connessione con browser.
# $_[5] <== Query ( puo' essere undef(), "" o "arg1=value1&arg2=value2" )
# $_[6] <== Se comando HTTP e' POST puo' darsi che dopo headers segua il
#           il valore della form. Questo valore potrebbe essere una parte.
#           il resto deve essere acquisito con piu' sysread $_[4], $scalare
#           fino a che si legge "\r\n" o se enc-type diverso fino a che si
#           legge il boundary di fine form.

sub resourcenotfound
{
  my $contenttype = "";
  my $contentlength = 0;
  my $instring = "";
  my $hname = '';
  my $hvalue = '';
  
  my $form = $_[6];
  
  if (uc($_[1]) eq "POST")
    {
      for my $temp (@{$_[0]})
        {
          ($hname, $hvalue) = split(/:\s/, $temp, 2);
          if (lc($hname) eq "content-type")
            { $contenttype = $hvalue; }
          elsif (lc($hname) eq "content-length")
            { $contentlength = $hvalue; $hvalue =~ s/\D//go;}
        }
    }
    
  $contentlength -= length $_[6];

  alarm 30;
  my $nread = 1;
  while (($contentlength > 0) && $nread)
    {
      $nread = sysread $_[4], $instring, 8192;
      
      syswrite STDOUT, "$contentlength input $nread\n";
      # *elabora o trasmetti a CGI lettura parziale dati FORM.
      $form .= $instring;
      # /elabora o trasmetti a CGI lettura parziale dati FORM.
      
      $contentlength -= $nread;
      alarm 30;
    }

  syswrite $_[4],
    "HTTP/1.1 200 OK\r\nContent-type: text/html\r\n\r\n".
    '<HTML><HEAD><TITLE>Metodo '. $_[1] .
    ' Risorsa ' . $_[2] . '</TITLE></HEAD><BODY>'."\r\n";

  syswrite $_[4], "Metodo: $_[1]".'<BR>'.
                  "Risorsa: $_[2]".'<BR>'.
                  "Query: $_[5]".'<BR>'.
                  "Versione HTTP: $_[3]".'<HR>'."\r\n";
    
  for my $outstring (@{$_[0]})
    {
      syswrite STDOUT, $outstring."\n";
      syswrite REMOTE, $outstring.'<BR>'."\r\n";
    }
    
  syswrite STDOUT, "\n--\n$form\n--\n";
    
  syswrite $_[4], '<HR>'. $form . '<BR>'."\r\n";
    
  syswrite $_[4], "\r\n".'</BODY></HTML>'."\r\n";

}
